jvx.thirdParty.acmeGui

## Class BusyBox

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - jvx.thirdParty.acmeGui.BusyBox

- All Implemented Interfaces:
    java.awt.event.WindowListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Runnable, java.util.EventListener, javax.accessibility.Accessible

      public class BusyBox
      extends java.awt.Dialog
      implements java.lang.Runnable, java.awt.event.WindowListener

  A busy-box.

  Puts up a dialog with a specified message. All user input is locked out. When the program is done with its task, it can unlock things by calling the done() method.

  Sample usage:

  >      BusyBox b = new BusyBox( this, "Sample BusyBox" );
  >      b.start();
  >      [your task here]
  >      b.done();

  NOTE: do not use this inside an event handler call! With some browsers this will cause a deadlock. Instead, have your event handler start a new thread to run the busy box and task.

  Operation can be aborted by clicking on the destroy field of the busy box dialog. The busy box sends an action event to registered action listeners when operation is aborted. This method does not dispose this dialog which still must be done by the calling class. This allows to keep this dialog visible and showing the "Aborting ..." message until all clean-up has been done by the calling class.

  Copyright (C)1996,1998 by Jef Poskanzer (jef@acme.com). All rights reserved.

  Visit the ACME Labs Java page for up-to-date versions of this and other fine Java utilities: http://www.acme.com/java/

  See Also:
    Serialized Form
  Version:
    03.10.07, 2.00 revised (kp) User must now call start() and no longer call run() or show() since java.awt.Dialog now calls Component#show().
    21.07.02, 1.30 revised (kp) Abortion of operation implemented.
    08.06.02, 1.20 revised (ep) First pack() then setResizable(false).
    20.12.01, 1.10 revised (ep) Internationalization.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.awt.Dialog

      `java.awt.Dialog.ModalExclusionType, java.awt.Dialog.ModalityType`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    - ### Fields inherited from class java.awt.Dialog

      `DEFAULT_MODALITY_TYPE`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BusyBox(java.awt.Frame parent, java.lang.String message)` Constructor, default title.
    `BusyBox(java.awt.Frame parent, java.lang.String title, java.lang.String message)` Constructor, specified title.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addActionListener(java.awt.event.ActionListener listener)` Action events are sent when a user clicks on Ok or Cancel button, doubleclicks on a model in the model dialog or presses <return> in the textfield of the small info panel.
    `void` | `done()`
    `void` | `removeActionListener(java.awt.event.ActionListener listener)` Removes (one occurrence of) a listener from internal list.
    `void` | `run()`
    `void` | `start()` Show the box.
    `void` | `windowActivated(java.awt.event.WindowEvent event)` Method does nothing.
    `void` | `windowClosed(java.awt.event.WindowEvent event)` Method does nothing.
    `void` | `windowClosing(java.awt.event.WindowEvent event)` Send an action event to a listener if user clicks on 'delete'-cross of title bar.
    `void` | `windowDeactivated(java.awt.event.WindowEvent event)` Method does nothing.
    `void` | `windowDeiconified(java.awt.event.WindowEvent event)` Method does nothing.
    `void` | `windowIconified(java.awt.event.WindowEvent event)` Method does nothing.
    `void` | `windowOpened(java.awt.event.WindowEvent event)` Method does nothing.

    - ### Methods inherited from class java.awt.Dialog

      `addNotify, getAccessibleContext, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setBackground, setModal, setModalityType, setOpacity, setResizable, setShape, setTitle, setUndecorated, setVisible, show, toBack`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, dispatchEvent, enable, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BusyBox

          public BusyBox(java.awt.Frame parent,
                         java.lang.String message)

      Constructor, default title.

    - #### BusyBox

          public BusyBox(java.awt.Frame parent,
                         java.lang.String title,
                         java.lang.String message)

      Constructor, specified title.

  - ### Method Detail

    - #### start

          public void start()

      Show the box.
      Version:
        03.10.07, 1.10 revised (kp) Renamed to start() from show() since java.awt.Dialog now calls Component#show().

    - #### run

          public void run()

      Specified by:
        `run` in interface `java.lang.Runnable`

    - #### done

          public void done()

    - #### windowOpened

          public void windowOpened(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowOpened` in interface `java.awt.event.WindowListener`

    - #### windowClosed

          public void windowClosed(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowClosed` in interface `java.awt.event.WindowListener`

    - #### windowDeiconified

          public void windowDeiconified(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowDeiconified` in interface `java.awt.event.WindowListener`

    - #### windowIconified

          public void windowIconified(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowIconified` in interface `java.awt.event.WindowListener`

    - #### windowDeactivated

          public void windowDeactivated(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowDeactivated` in interface `java.awt.event.WindowListener`

    - #### windowActivated

          public void windowActivated(java.awt.event.WindowEvent event)

      Method does nothing.
      Specified by:
        `windowActivated` in interface `java.awt.event.WindowListener`

    - #### windowClosing

          public void windowClosing(java.awt.event.WindowEvent event)

      Send an action event to a listener if user clicks on 'delete'-cross of title bar. Note, this method does not dispose this dialog which still must be done by the calling class. This allows to keep this dialog visible and showing the "Aborting.." message until all clean-up has been done by the calling class.
      Specified by:
        `windowClosing` in interface `java.awt.event.WindowListener`
      Version:
        21.07.02, 1.00 created (kp)

    - #### addActionListener

          public void addActionListener(java.awt.event.ActionListener listener)

      Action events are sent when a user clicks on Ok or Cancel button, doubleclicks on a model in the model dialog or presses <return> in the textfield of the small info panel. The event is sent after the model is loaded.

    - #### removeActionListener

          public void removeActionListener(java.awt.event.ActionListener listener)

      Removes (one occurrence of) a listener from internal list. Registered listeners will be effected by `fireAction(ActionEvent)`.

"

The software JavaView? is copyright protected. All Rights Reserved.
"